// SampleAppDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SampleApp.h"
#include "SampleAppDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// Status Strings
#define STATUS_OPENED				"OMCR was opened."
#define STATUS_CLOSED				"OMCR was closed."
#define STATUS_READ					"Read succeeded."
#define STATUS_READFAILURE			"Read failed."
#define STATUS_READSTOPPED			"Reading stopped"

#define NOTICE_CARDNOTPRESENT		"Check that any card is not present in the card reader."
#define NOTICE_CARDPRESENT			"Check that a card is present in the card reader."
#define NOTICE_INSERTION			"Please insert a card."
#define NOTICE_PULLOUT				"Please pull out the card."

// For Reading Radio Buttons
#define DIR_INSERTION				0
#define DIR_BACK					1

// Reading Thread sends Windows Messages to the Main Thread
#define DISPLAY_READDATA			WM_USER+0
#define DISPLAY_STATUS				WM_USER+1


static DWORD WINAPI Reading(LPVOID lpArg);
DWORD CheckReadStatus(LPCOMCR_CARDSTATUS lpcCardStatus);

//5VCardData
char Toppan5VATR[] = "3B F0 11 00 FF 81 31 45 46 AD ";
//3VCardData
char Toppan3VATR[] = "3B E0 00 FF 81 B1 FC 45 1F 03 8A ";

//For IC data display
char toppan5[256] = "Toppan 5V IC Card\r\n";
char toppan3[128] = "Toppan 3V IC Card\r\n";
char buffer[128] = "\0";

//It performs only once
int flg1 = 0;
int flg2 = 0;
//LED control sake
int flg3 = 0;
int flg4 = 0;
int flg5 = 0;
int flg6 = 0;
//The flag for error processing
int flg7 = 0;
//TRUE or FALSE
BOOL flg;
BOOL WINAPI TransAsciiToBinary( CString strAsc, BYTE* pBin, int *nLen );
//------------------------------------------------------------------------
// Reading Thread
//	sends OMCR_MonitorCardStatus() unless StopReading() is
//	called by the main thread. StopReading() calls only OMCR_Cancel();
//	When Reading Thread detects OMCR_STATUS_CANCELLED, quit loop.
//------------------------------------------------------------------------
static DWORD WINAPI Reading( LPVOID lpArg )
{
	CSampleAppDlg*	lpDlg = ( CSampleAppDlg* )lpArg;
	LPCOMCR			lpcOmcr = lpDlg->GetOmcr();
	CString			strMessage;
	DWORD			dwRet;
	OMCR_CARDSTATUS	CardStatus;
	OMCR_MAGTRACK	MagTrack;
	DWORD			dwReadTrack;
	
	while ( 1 ) {
		// Sends OMCR_MonitorCardStatus to check the card insertion or pulling-out
		dwRet = OMCR_MonitorCardStatus(lpcOmcr, 10, &CardStatus, NULL);
		switch ( dwRet ) {
		case OMCR_STATUS_CANCELLED:
			// quit loop and finish the thread
			return 0;
			break;
		case OMCR_STATUS_SUCCESS:
			//Check Card Status
			if ( CardStatus.dwTrack1 == OMCR_CARD_STATUS_NOREADING &&
				 CardStatus.dwTrack2 == OMCR_CARD_STATUS_NOREADING &&
				 CardStatus.dwTrack3 == OMCR_CARD_STATUS_NOREADING )
			{
				// Different Direction
				break;
			}
			dwReadTrack = CheckReadStatus(&CardStatus);
			dwRet = OMCR_ReadMagTrack( lpcOmcr, dwReadTrack, &MagTrack, NULL );
			if( dwRet == OMCR_STATUS_SUCCESS ) 
			{
				lpDlg->SendMessage( DISPLAY_READDATA, -1, ( LPARAM )( &MagTrack ) );
				lpDlg->SendMessage( DISPLAY_STATUS, -1, ( LPARAM )( STATUS_READ ) );
			} else {
				lpDlg->DisplayErrorMessage( "OMCR_ReadMagTrack", dwRet );
				lpDlg->SendMessage( DISPLAY_READDATA, -1, ( LPARAM )( NULL ) );
			}
			break;
		case OMCR_WRN_FUNC_MED_INTAKETIMEOUT:
			// Ignore
			break;
		default:
			// other errors
			// quit loop and finish the thread
			strMessage.Format( "Error ( OMCR_MonitorCardStatus ) : 0x%08X", dwRet );
			MessageBox( NULL, "Error", strMessage, MB_OK );
			return 0;
		}
	}
	return 0;
}

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();
	
	// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA
	
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL
	
	// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog( CAboutDlg::IDD )
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange( CDataExchange* pDX )
{
	CDialog::DoDataExchange( pDX );
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP( CAboutDlg, CDialog )
//{{AFX_MSG_MAP(CAboutDlg)
// No message handlers
//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSampleAppDlg dialog

CSampleAppDlg::CSampleAppDlg( CWnd* pParent /*=NULL*/ )
: CDialog( CSampleAppDlg::IDD, pParent )
{
	//{{AFX_DATA_INIT(CSampleAppDlg)
	m_strSerialNumber = _T("");
	m_strReadData = _T("");
	m_nReadDirection = -1;
	m_strDevice = _T("");
	m_strICData = _T("");
	m_strICCRW = _T("");
	m_strICWriteD = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon( IDR_MAINFRAME );
}

void CSampleAppDlg::DoDataExchange( CDataExchange* pDX )
{
	CDialog::DoDataExchange( pDX );
	//{{AFX_DATA_MAP(CSampleAppDlg)
	DDX_Control(pDX, IDC_EDIT_Status, m_edtStatus);
	DDX_Text(pDX, IDC_EDIT_SerialNumber, m_strSerialNumber);
	DDX_Text(pDX, IDC_EDIT_ReadData, m_strReadData);
	DDX_Radio(pDX, IDC_RADIO_Insertion, m_nReadDirection);
	DDX_CBString(pDX, IDC_COMBO_Device, m_strDevice);
	DDX_Text(pDX, IDC_EDIT2, m_strICData);
	DDX_Text(pDX, IDC_EDIT1, m_strICCRW);
	DDX_Text(pDX, IDC_EDIT3, m_strICWriteD);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP( CSampleAppDlg, CDialog )
//{{AFX_MSG_MAP(CSampleAppDlg)
ON_WM_SYSCOMMAND()
ON_WM_PAINT()
ON_WM_QUERYDRAGICON()
ON_BN_CLICKED(IDC_BUTTON_OpenDevice, OnBUTTONOpenDevice)
ON_BN_CLICKED(IDC_BUTTON_CloseDevice, OnBUTTONCloseDevice)
ON_BN_CLICKED(IDC_BUTTON_InitialReset, OnBUTTONInitialReset)
ON_BN_CLICKED(IDC_BUTTON_Activate, OnBUTTONActivateICC)
ON_WM_DESTROY()
ON_BN_CLICKED(IDC_RADIO_Insertion, OnRADIOInsertion)
ON_BN_CLICKED(IDC_RADIO_Back, OnRADIOBack)
ON_MESSAGE(DISPLAY_READDATA,OnDisplayReadData)
ON_MESSAGE(DISPLAY_STATUS,OnDisplayStatus)
ON_BN_CLICKED(IDC_BUTTON_ICCRead, OnBUTTONICCRead)
ON_BN_CLICKED(IDC_BUTTON_ICCWrite, OnBUTTONICCWrite)
ON_BN_CLICKED(IDC_BUTTON_LEDG, OnButtonLedG)
ON_BN_CLICKED(IDC_RADIO_Insertion4, OnRADIO1sec)
ON_BN_CLICKED(IDC_BUTTON_LEDR, OnButtonLedR)
ON_BN_CLICKED(IDC_BUTTON_LEDO, OnButtonLedgO)
ON_BN_CLICKED(IDC_RADIO_Insertion3, OnRADIOSec2)
ON_BN_CLICKED(IDC_RADIO_Insertion2, OnRADIOSec4)
ON_BN_CLICKED(IDC_RADIO_Insertion5, OnRADIOmsec500)
ON_BN_CLICKED(IDC_RADIO_Insertion6, OnRADIOmsec250)
ON_BN_CLICKED(IDC_RADIO_Insertion7, OnRADIOsec0)
ON_BN_CLICKED(IDC_BUTTON_LEDOUT, OnButtonLedout)
//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSampleAppDlg message handlers

BOOL CSampleAppDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	
	// Add "About..." menu item to system menu.
	// IDM_ABOUTBOX must be in the system command range.
	ASSERT( ( IDM_ABOUTBOX & 0xFFF0 ) == IDM_ABOUTBOX );
	ASSERT( IDM_ABOUTBOX < 0xF000 );	
	CMenu* pSysMenu = GetSystemMenu( FALSE );

	if ( pSysMenu != NULL )
	{
		CString strAboutMenu;
		strAboutMenu.LoadString( IDS_ABOUTBOX );

		if ( !strAboutMenu.IsEmpty() )
		{
			pSysMenu->AppendMenu( MF_SEPARATOR );
			pSysMenu->AppendMenu( MF_STRING, IDM_ABOUTBOX, strAboutMenu );
		}
	}
	
	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon( m_hIcon, TRUE );			// Set big icon
	SetIcon( m_hIcon, FALSE );		// Set small icon
	// Initializing Process ...
	this->lpcOmcr = NULL;
	this->m_nReadDirection = DIR_INSERTION;
	this->m_hReadThread = NULL;
	this->m_strSerialNumber.Empty();
	this->m_strDevice = "USB";
	UpdateData( FALSE );
//	StopReading();
	OMCR_TurnoffLED( this->lpcOmcr, NULL );
//	OMCR_InitialReset(this->lpcOmcr,NULL);

	DisableButtons();
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CSampleAppDlg::OnSysCommand( UINT nID, LPARAM lParam )
{
	if ( ( nID & 0xFFF0 ) == IDM_ABOUTBOX )
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand( nID, lParam );
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSampleAppDlg::OnPaint() 
{
	if ( IsIconic() )
	{
		CPaintDC dc( this ); // device context for painting
		
		SendMessage( WM_ICONERASEBKGND, ( WPARAM ) dc.GetSafeHdc(), 0 );
		
		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics( SM_CXICON );
		int cyIcon = GetSystemMetrics( SM_CYICON );
		CRect rect;
		GetClientRect( &rect );
		int x = ( rect.Width() - cxIcon + 1 ) / 2;
		int y = ( rect.Height() - cyIcon + 1 ) / 2;
		
		// Draw the icon
		dc.DrawIcon( x, y, m_hIcon );
	}
	else {
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSampleAppDlg::OnQueryDragIcon()
{
	return ( HCURSOR ) m_hIcon;
}


//========================================================================
// Message Handle Functions
//========================================================================
//------------------------------------------------------------------------
// On "OpenDevice"
//------------------------------------------------------------------------
void CSampleAppDlg::OnBUTTONOpenDevice() 
{
	// Try Closing once
	OMCR_InitialReset(this->lpcOmcr,NULL);
	
	CloseDevice();
	if ( flg7 ) {
		DWORD dwLastError;
		char SNumber[512];
		OMCR_InitialReset( this->lpcOmcr, NULL );
		OMCR_GetSerialNumber( this->lpcOmcr, SNumber, NULL );
		m_strSerialNumber = SNumber;
		this->lpcOmcr = NULL;
		DWORD dwRet = OMCR_DeactivateICC( this->lpcOmcr, NULL );
		dwRet = OMCR_STATUS_SUCCESS;
		dwLastError = NULL;
		OnBUTTONInsertion();
	}
	if( !OpenDevice() )
	{
		char buff[513];
		DWORD dwLastError;
		dwLastError = GetLastError();
		
		FormatMessage( FORMAT_MESSAGE_FROM_SYSTEM,NULL,dwLastError,0 ,buff,512,NULL );
		MessageBox( buff, "OMCR_OpenDevice" );
		DisableButtons();
		OnBUTTONInsertion();
	} else {
		// Clear Read Data
		char SNumber[512];
	//	OMCR_InitialReset( this->lpcOmcr, NULL );
		OMCR_GetSerialNumber( this->lpcOmcr, SNumber, NULL );
		m_strSerialNumber = SNumber;
		this->m_strReadData.Empty();
		UpdateData( FALSE );
		// Display "Opened" 
		DisplayStatus( STATUS_OPENED );
		
		// Enable operation buttons in success of OMCR_OpenDevice
		EnableButtons();
		OMCR_SetLEDControlMode( this->lpcOmcr, OMCR_LEDCTRLMODE_MANUAL, NULL );
//		StopReading();
		OMCR_TurnoffLED( this->lpcOmcr, NULL );
//		OMCR_InitialReset(this->lpcOmcr,NULL);		// Initial Reset
		
		// Start Reading Thread

		StartReading();
	}
}

//------------------------------------------------------------------------
// On "CloseDevice"
//------------------------------------------------------------------------
void CSampleAppDlg::OnBUTTONCloseDevice() 
{
//	StopReading();
	DWORD dwRet = CloseDevice();
	if(	dwRet != OMCR_STATUS_SUCCESS )
	{
		DisplayErrorMessage( "OMCR_CloseDevice", dwRet );
	} else {
		//Disable operation buttons in success of OMCR_CloseDevice
		DisplayStatus( STATUS_CLOSED );
		DisableButtons();
	}
}

//------------------------------------------------------------------------
// On "InitialReset"
// Obsolete...
//------------------------------------------------------------------------
void CSampleAppDlg::OnBUTTONInitialReset() 
{
	DWORD dwRet = OMCR_InitialReset( lpcOmcr, NULL );
	if( dwRet != OMCR_STATUS_SUCCESS )
	{
		DisplayErrorMessage( "OMCR_InitialReset", dwRet );
	}
}

//------------------------------------------------------------------------
// On "Activate" or "Deactivate"
//------------------------------------------------------------------------
void CSampleAppDlg::OnBUTTONActivateICC() 
{
	DWORD dwRet;
	UpdateData(TRUE);
	
	//Get the OMCR status "Activate" or "Deactivate"
	CString strLockStatus;
	CButton* ActivateBtn = ( CButton* )GetDlgItem( IDC_BUTTON_Activate );
	ActivateBtn->EnableWindow( TRUE );
	ActivateBtn->GetWindowText( strLockStatus );
	
	if ( strLockStatus == "Activate" )
	{
		dwRet = Activate();	
	} else {	
		dwRet = Deactivate();
	}
	
	if ( dwRet != OMCR_STATUS_SUCCESS )
	{
		Deactivate();
		DisplayErrorMessage( "OMCR_" +strLockStatus, dwRet );
	}
//	UpdateData(FALSE);
	return;
}

//------------------------------------------------------------------------
// On "Insertion Reading"
// Obsolete...
// (1) Deactivate to insert a card
// (2) Set to Insertion Reading by "OMCR_PrepareTransactionSetting"
// (3) Wait for insertion a card by "OMCR_MonitorCardStatus"
// (4) Read magnetic data by "OMCR_ReadMagTrack"
//------------------------------------------------------------------------
void CSampleAppDlg::OnBUTTONInsertion() 
{
	DisplayStatus(NOTICE_INSERTION);
	
	DWORD dwRet;
	//Open Activate
	dwRet = Deactivate();

	if( dwRet != OMCR_STATUS_SUCCESS )
	{
		DisplayErrorMessage( "OMCR_Deactivate", dwRet );
		return;
	}
	
	//Setting
	OMCR_SETTINGS	Settings;
	Settings.dwReadDirection	= OMCR_SET_TRANS_INSERTIONREADING;
	Settings.dwReadTracks		= OMCR_READ_TRACK_ISO1 | OMCR_READ_TRACK_ISO2 | OMCR_READ_TRACK_ISO3;
	Settings.bInsert			= FALSE;
	Settings.bPullout			= FALSE;
	dwRet = OMCR_PrepareTransactionSetting( this->lpcOmcr, &Settings, NULL );
	
	if( dwRet != OMCR_STATUS_SUCCESS )
	{
		DisplayErrorMessage( "OMCR_Deactivate", dwRet );
		return;
	}
	
	//Wait Insertion
	BeginWaitCursor();
	OMCR_CARDSTATUS	CardStatus;
	dwRet = OMCR_MonitorCardStatus( this->lpcOmcr, 10, &CardStatus, NULL );	//Wait 30 secs
	EndWaitCursor();
	
	if( dwRet != OMCR_STATUS_SUCCESS )
	{

		if( dwRet == OMCR_WRN_FUNC_MED_INTAKETIMEOUT )
		{
			//Timeout
			MessageBox( "Please Insert a card !", "Notice" );
		} else {
			DisplayErrorMessage( "OMCR_MonitorCardStatus", dwRet );
			DisplayReadData( NULL );
		}

		return;
	}
	
	//Check Read Status
	DWORD dwReadTracks = CheckReadStatus( &CardStatus );
	
	if( dwReadTracks == 0 )
	{
		DisplayReadData( NULL );
		return;
	}
	
	//Display Read Data
	OMCR_MAGTRACK	MagTrack;
	dwRet = OMCR_ReadMagTrack( this->lpcOmcr, dwReadTracks, &MagTrack, NULL );
	
	if( dwRet != OMCR_STATUS_SUCCESS )
	{
		DisplayErrorMessage( "OMCR_ReadMagTrack",dwRet );
		DisplayReadData( NULL );
		return;
	}
	
	DisplayReadData( &MagTrack );
	DisplayStatus( STATUS_READ );
}

//------------------------------------------------------------------------
// On "Back Reading"
// Obsolete...
// (1) Deactivate to pull-out a card
// (2) Set to Back Reading by "OMCR_PrepareTransactionSetting"
// (3) Wait for pulling-out a card by "OMCR_MonitorCardStatus"
// (4) Read magnetic data by "OMCR_ReadMagTrack"
//------------------------------------------------------------------------
void CSampleAppDlg::OnBUTTONBack() 
{
	DisplayStatus( NOTICE_PULLOUT );
	
	DWORD dwRet;
	//Open Anactivate
	dwRet = Deactivate();
	
	if( dwRet != OMCR_STATUS_SUCCESS )
	{
		DisplayErrorMessage( "OMCR_Deactivate", dwRet );
		return;
	}
	
	//Setting
	OMCR_SETTINGS	Settings;
	Settings.dwReadDirection	= OMCR_SET_TRANS_BACKREADING;
	Settings.dwReadTracks		= OMCR_READ_TRACK_ISO1 | OMCR_READ_TRACK_ISO2 | OMCR_READ_TRACK_ISO3;
	Settings.bInsert			= FALSE;
	Settings.bPullout			= FALSE;
	dwRet = OMCR_PrepareTransactionSetting( this->lpcOmcr, &Settings, NULL );
	
	if( dwRet != OMCR_STATUS_SUCCESS )
	{
		DisplayErrorMessage( "OMCR_Deactivate", dwRet );
		return;
	}
	
	//Wait Pull out
	BeginWaitCursor();
	OMCR_CARDSTATUS	CardStatus;
	dwRet = OMCR_MonitorCardStatus( this->lpcOmcr, 10, &CardStatus, NULL );	//Wait 30 secs
	EndWaitCursor();
	
	if( dwRet != OMCR_STATUS_SUCCESS )
	{
	
		if( dwRet == OMCR_WRN_FUNC_MED_INTAKETIMEOUT )
		{
			//Timeout
			MessageBox( "Please Insert a card !", "Notice" );
		} else {
			DisplayErrorMessage( "OMCR_MonitorCardStatus", dwRet );
			DisplayReadData( NULL );
		}
		return;
	}
	
	//Check Read Status
	DWORD dwReadTracks = CheckReadStatus( &CardStatus );
	
	if( dwReadTracks == 0 )
	{
		DisplayReadData( NULL );
		return;
	}
	
	//Display Read Data
	OMCR_MAGTRACK	MagTrack;
	dwRet = OMCR_ReadMagTrack( this->lpcOmcr, dwReadTracks, &MagTrack, NULL );
	
	if( dwRet!=OMCR_STATUS_SUCCESS )
	{
		DisplayErrorMessage( "OMCR_ReadMagTrack", dwRet );
		DisplayReadData( NULL );
		return;
	}
	
	DisplayReadData( &MagTrack );
	DisplayStatus( STATUS_READ );
}

//------------------------------------------------------------------------
// On Closing
//------------------------------------------------------------------------
void CSampleAppDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	//Terminate Process ...
	StopReading();
	Deactivate();			// Release Anactivate
	CloseDevice();		// Close OMCR Device
}

//------------------------------------------------------------------------
// On "Insertion Reading" Radio
//------------------------------------------------------------------------
void CSampleAppDlg::OnRADIOInsertion() 
{
	if( this->m_nReadDirection == DIR_BACK || this->m_hReadThread == NULL )
	{
		StartReading();
		this->m_strReadData.Empty();
		UpdateData( FALSE );
	}
}

//------------------------------------------------------------------------
// On "Back Reading" Radio
//------------------------------------------------------------------------
void CSampleAppDlg::OnRADIOBack() 
{
	if( this->m_nReadDirection == DIR_INSERTION || this->m_hReadThread == NULL )
	{
		StartReading();
		this->m_strReadData.Empty();
		UpdateData( FALSE );
	}
}

//------------------------------------------------------------------------
// On "DISPLAY_READDATA" Message
//	This message is sent by the Reading thread
//------------------------------------------------------------------------
void CSampleAppDlg::OnDisplayReadData( WPARAM wParam, LPARAM lParam )
{
	if( wParam )
	{
		DisplayReadData( ( LPCOMCR_MAGTRACK )lParam );
	}
}

//------------------------------------------------------------------------
// On "DISPLAY_STATUS" Message
//	This message is sent by the Reading thread
//------------------------------------------------------------------------
void CSampleAppDlg::OnDisplayStatus( WPARAM wParam, LPARAM lParam )
{
	if( wParam )
	{
		DisplayStatus( ( const char* ) lParam );
	}
}

//========================================================================
// OMCR API Handling Functions
//========================================================================
//------------------------------------------------------------------------
// OMCR_OpenDevice
//------------------------------------------------------------------------
BOOL CSampleAppDlg::OpenDevice()
{
	UpdateData( TRUE );
	//Type
	if ( this->m_strDevice == "USB" ) 
	{
		//When SerialNumber is NULL, open the first detected OMCR.
		if ( this->m_strSerialNumber == "" ) 
		{
			OMCR_InitialReset( this->lpcOmcr, NULL );
			this->lpcOmcr = OMCR_OpenDevice( NULL, NULL );
		} else {
			this->lpcOmcr = OMCR_OpenDevice( this->m_strSerialNumber, NULL );
		}
	} else {
		OMCR_OPTION	Option;
		Option.Device.COM.dwBaudRate = OMCR_BAUDRATE_19200;
		this->lpcOmcr = OMCR_OpenDevice( this->m_strDevice, &Option );
	}
	
	//Get SerialNumber
	if ( this->lpcOmcr != NULL ) 
	{	
		char SNumber[512];
		OMCR_InitialReset( this->lpcOmcr, NULL );
		OMCR_GetSerialNumber( this->lpcOmcr, SNumber, NULL );
		m_strSerialNumber = SNumber;
		return TRUE;
	} else {	
	//	this->lpcOmcr = OMCR_OpenDevice(NULL,NULL);
		return FALSE;
	}
}

//------------------------------------------------------------------------
// OMCR_CloseDevice
//------------------------------------------------------------------------
DWORD CSampleAppDlg::CloseDevice()
{
	DWORD dwRet = OMCR_STATUS_SUCCESS;
	
//	UpdateData(TRUE);
	StopReading();
//@Turn off LED
	OMCR_TurnoffLED( this->lpcOmcr, NULL );
	
	dwRet = OMCR_DeactivateICC( this->lpcOmcr, NULL );
	
	EnableButtons();
	UpdateData(TRUE);
//Clear in display data
	this->m_strSerialNumber.Empty();
	this->m_strICData.Empty();
	this->m_strICWriteD.Empty();
	this->m_strReadData.Empty();
	this->m_strICCRW.Empty();
	
	if( this->lpcOmcr != NULL )
	{
		DWORD dwRet = OMCR_CloseDevice( lpcOmcr );
		
		if( dwRet == OMCR_STATUS_SUCCESS )
		{
			this->lpcOmcr = NULL;
			this->m_strSerialNumber.Empty();
		}
		else {
			OMCR_InitialReset( this->lpcOmcr, NULL );
			this->lpcOmcr = NULL;
			this->m_strSerialNumber.Empty();
			flg7 = 1;
		}
	}
	
	UpdateData( FALSE );
	return dwRet;
}

//------------------------------------------------------------------------
// OMCR_Anactivate
//------------------------------------------------------------------------
DWORD CSampleAppDlg::Activate()
{
	//Set Activate and Change the Button Text to "Deactivate" when API succeed
	DWORD dwRet = OMCR_STATUS_SUCCESS;
	DWORD dd = OMCR_IC_COLDRESET;
	OMCR_ICCIO lpATR;
	//A binary conversion sake
	char ICDatabuff[3];
	UpdateData( TRUE );

	if ( this->lpcOmcr != NULL ) 
	{	
		StopReading();
		flg = TRUE;
		//Get ICCData	
		dwRet = OMCR_ActivateICC( lpcOmcr, dd, &lpATR, this->m_hReadThread );
		
		if ( dwRet == OMCR_STATUS_SUCCESS ) 
		{
			//Change the text to "Deactivate"
			ChangeToDeactivate();
			
			//A write-in space
			CButton* WriteS = ( CButton* )GetDlgItem( IDC_EDIT3 );
			WriteS->SetFocus();
			
			CButton* ActivateBtn = ( CButton* )GetDlgItem( IDC_BUTTON_Activate );
			ActivateBtn->EnableWindow( TRUE );
			ActivateBtn->SetButtonStyle( TBBS_BUTTON, TRUE );

			//Enable WriteERead Button
			CButton* ReadBtn = ( CButton* )GetDlgItem( IDC_BUTTON_ICCRead );	
			ReadBtn->EnableWindow( TRUE );

			CButton* WriteBtn = (CButton*)GetDlgItem( IDC_BUTTON_ICCWrite );	
			WriteBtn->EnableWindow( TRUE );
			SetDefID( IDC_BUTTON_ICCWrite );

			DisplayStatus( STATUS_READSTOPPED );
			this->m_strReadData.Empty();
			memset( buffer, 0x00, sizeof( buffer ) );
			
			for ( UINT i = 0; i < lpATR.uLength; i++ ) 
			{
				sprintf( ICDatabuff, "%02X ", lpATR.bData[i] );
				strcat( buffer, ICDatabuff );				
			}
			//ICC Data Display
			//The display of 5V card data
			if ( strcmp( buffer, Toppan5VATR ) == 0 ) 
			{

				if ( flg1 == 0 ) 
				{
					strcat(toppan5,buffer);
					flg1 = 1;
				}
				
				this->m_strICData = toppan5;				
			}
			//The display of 3V card data
			else if ( strcmp( buffer, Toppan3VATR ) == 0 ) 
			{
				
				if ( flg2 == 0 ) 
				{
					strcat( toppan3, buffer );
					flg2 = 1;
				}
				
				this->m_strICData = toppan3;
			}
			//Other Cards
			else {
				this->m_strICData = "Other cards";
				CButton *pBtn = ( CButton* )GetDlgItem( IDC_BUTTON_ICCRead );
				pBtn->EnableWindow( FALSE );
				pBtn = ( CButton* )GetDlgItem( IDC_BUTTON_ICCWrite );
				pBtn->EnableWindow( FALSE );
			}
			UpdateData( FALSE );
			DisableReadButton();
		} else {	
			this->m_strICData = "Failure";
			//Deactivate();		
			UpdateData( FALSE );			
		}
	}

	return dwRet;
}

//------------------------------------------------------------------------
// OMCR_Deactivate
//------------------------------------------------------------------------
DWORD CSampleAppDlg::Deactivate()
{
	//Release Activate and Change the Button Text to "Activate" when API succeed
	DWORD dwRet = OMCR_STATUS_SUCCESS;
	StopReading();
	//Clear in display data
	UpdateData( TRUE );
	this->m_strICData = "";
	this->m_strICCRW = "";
	this->m_strICWriteD = "";
	flg = FALSE;
	
	UpdateData( FALSE );
	
	if ( this->lpcOmcr != NULL ) 
	{	
//		StopReading();
		dwRet = OMCR_DeactivateICC( this->lpcOmcr, NULL );
		
		if ( dwRet == OMCR_STATUS_SUCCESS ) 
		{
			//Change the text to "Activate"
			ChangeToActivate();
			//ICCRead,ICCWritẽ{^𖳌\
			CButton* ReadBtn = ( CButton* )GetDlgItem( IDC_BUTTON_ICCRead );
			ReadBtn->EnableWindow( FALSE );
			CButton* WriteBtn = (CButton*)GetDlgItem(IDC_BUTTON_ICCWrite);
			WriteBtn->EnableWindow(FALSE);
			
			StartReading();
		}
	}
	return dwRet;
}

//------------------------------------------------------------------------
// StartReading
//	OMCR_PrepareTransactionSetting sends parameters depending on Radio button
//	Start Reading Thread
//------------------------------------------------------------------------
void CSampleAppDlg::StartReading()
{
	// Stop running thread
	StopReading();
	// Call OMCR_PrepareTransactionSetting
	UpdateData( TRUE );
	DWORD			dwRet;
	OMCR_SETTINGS	Settings;
	Settings.dwReadDirection	= this->m_nReadDirection == DIR_INSERTION?OMCR_SET_TRANS_INSERTIONREADING:OMCR_SET_TRANS_BACKREADING;
	Settings.dwReadTracks		= OMCR_READ_TRACK_ISO1 | OMCR_READ_TRACK_ISO2 | OMCR_READ_TRACK_ISO3;
	Settings.bInsert			= FALSE;
	Settings.bPullout			= FALSE;
	dwRet = OMCR_PrepareTransactionSetting( lpcOmcr, &Settings, NULL );
	
	if( dwRet != OMCR_STATUS_SUCCESS )
	{
		DisplayErrorMessage( "OMCR_PrepareTransactionSetting", dwRet );
	}
	
	// OMCR_PrepareTransactionSetting Deactivates automatically
	ChangeToActivate();
	// Create Reading Thread
	DWORD	dwThreadId;
	this->m_hReadThread = CreateThread( NULL, 0, Reading, this, 0, &dwThreadId );
	
	if( this->m_hReadThread == NULL )
	{
		DisplayErrorMessage( "CreateThread", GetLastError() );
	}
	
	// Change UserInterfaces
	DisplayReadStatus();
	EnableReadButton();
	
}

//------------------------------------------------------------------------
// StopReading
//	Call OMCR_Cancel to stop the running thread
//------------------------------------------------------------------------
void CSampleAppDlg::StopReading()
{
	if( this->m_hReadThread != NULL )
	{
		OMCR_Cancel( lpcOmcr );
		this->m_hReadThread = NULL;
	}
}

//========================================================================
// User Interface Functions
//========================================================================
//------------------------------------------------------------------------
// Enable Operation Buttons exclude "OpenDevice"
//------------------------------------------------------------------------
void CSampleAppDlg::EnableButtons()
{
	UpdateData( TRUE );
	CButton* OpenBtn = ( CButton* )GetDlgItem( IDC_BUTTON_OpenDevice );
	OpenBtn->SetButtonStyle( TBBS_BUTTON, TRUE );
	OpenBtn->EnableWindow( FALSE );
	CButton* CloseBtn = ( CButton* )GetDlgItem( IDC_BUTTON_CloseDevice );
	CloseBtn->EnableWindow( TRUE );

	CButton* ActivateBtn = ( CButton* )GetDlgItem( IDC_BUTTON_Activate );
	ActivateBtn->SetButtonStyle( BS_DEFPUSHBUTTON, TRUE );
	ActivateBtn->EnableWindow( TRUE );
	SetDefID( IDC_BUTTON_Activate );
	ActivateBtn->SetFocus();
	
	CButton* ReadBtn = ( CButton* )GetDlgItem( IDC_BUTTON_ICCRead );
	ReadBtn->EnableWindow(FALSE);

	CButton* WriteBtn = ( CButton* )GetDlgItem( IDC_BUTTON_ICCWrite );
	WriteBtn->EnableWindow( FALSE );
	
	CButton* RadioBtn = ( CButton* )GetDlgItem( IDC_RADIO_Insertion );
	RadioBtn->EnableWindow( TRUE );
	RadioBtn = ( CButton* )GetDlgItem( IDC_RADIO_Back );
	RadioBtn->EnableWindow( TRUE );
	
	CButton* LEDGBtn = ( CButton* )GetDlgItem( IDC_BUTTON_LEDG );
	LEDGBtn->EnableWindow( TRUE );
	CButton* LEDRBtn = ( CButton* )GetDlgItem( IDC_BUTTON_LEDR );
	LEDRBtn->EnableWindow( TRUE );
	CButton* LEDOBtn = ( CButton* )GetDlgItem( IDC_BUTTON_LEDO );
	LEDOBtn->EnableWindow( TRUE );
	CButton* LEDOUTBtn = ( CButton* )GetDlgItem( IDC_BUTTON_LEDOUT );
	LEDOUTBtn->EnableWindow( TRUE );

	RadioBtn = ( CButton* )GetDlgItem( IDC_RADIO_Insertion7 );
	RadioBtn->EnableWindow( TRUE );
	RadioBtn = ( CButton* )GetDlgItem( IDC_RADIO_Insertion6 );
	RadioBtn->EnableWindow( TRUE );
	RadioBtn = ( CButton* )GetDlgItem( IDC_RADIO_Insertion5 );
	RadioBtn->EnableWindow( TRUE );
	RadioBtn = ( CButton* )GetDlgItem( IDC_RADIO_Insertion4 );
	RadioBtn->EnableWindow( TRUE );
	RadioBtn = ( CButton* )GetDlgItem( IDC_RADIO_Insertion3 );
	RadioBtn->EnableWindow( TRUE );
	RadioBtn = ( CButton* )GetDlgItem( IDC_RADIO_Insertion2 );
	RadioBtn->EnableWindow( TRUE );
	
	flg6 = 1;
	CEdit* SerialNum = ( CEdit* )GetDlgItem( IDC_EDIT_SerialNumber );
	SerialNum->EnableWindow( FALSE );
	UpdateData( FALSE );
}

//------------------------------------------------------------------------
// Disable Operation Buttons exclude "OpenDevice"
//------------------------------------------------------------------------
void CSampleAppDlg::DisableButtons()
{
//	UpdateData(TRUE);
	CButton* OpenBtn = ( CButton* )GetDlgItem( IDC_BUTTON_OpenDevice );
	OpenBtn->EnableWindow( TRUE );
	OpenBtn->SetFocus();
	SetDefID( IDC_BUTTON_OpenDevice );
	
	if ( flg6 ) 
	{
		OpenBtn->SetButtonStyle( BS_DEFPUSHBUTTON, TRUE );
		OpenBtn->SetFocus();
	}

	CButton* CloseBtn = ( CButton* )GetDlgItem( IDC_BUTTON_CloseDevice );
	CloseBtn->EnableWindow( FALSE );
	CloseBtn->SetButtonStyle( TBBS_BUTTON, TRUE );

	CButton* ActivateBtn = ( CButton* )GetDlgItem( IDC_BUTTON_Activate );
	ActivateBtn->EnableWindow( FALSE );
	ActivateBtn->SetButtonStyle( TBBS_BUTTON, TRUE );

	CButton* ReadBtn = ( CButton* )GetDlgItem( IDC_BUTTON_ICCRead );
	ReadBtn->EnableWindow( FALSE );

	CButton* WriteBtn = ( CButton* )GetDlgItem( IDC_BUTTON_ICCWrite );
	WriteBtn->EnableWindow( FALSE );
	
	CButton* RadioBtn = ( CButton* )GetDlgItem( IDC_RADIO_Insertion );
	RadioBtn->EnableWindow( FALSE );
	RadioBtn = ( CButton* )GetDlgItem( IDC_RADIO_Back );
	RadioBtn->EnableWindow( FALSE );

	//Disable LED Buttons
	CButton* LEDGBtn = ( CButton* )GetDlgItem( IDC_BUTTON_LEDG );
	LEDGBtn->SetState( 0 );
	LEDGBtn->EnableWindow( FALSE );

	CButton* LEDRBtn = ( CButton* )GetDlgItem( IDC_BUTTON_LEDR );
	LEDRBtn->SetState( 0 );
	LEDRBtn->EnableWindow( FALSE );

	CButton* LEDOBtn = ( CButton* )GetDlgItem( IDC_BUTTON_LEDO );
	LEDOBtn->SetState( 0 );
	LEDOBtn->EnableWindow( FALSE );

	CButton* LEDOUTBtn = ( CButton* )GetDlgItem( IDC_BUTTON_LEDOUT );
	LEDOUTBtn->EnableWindow( FALSE );

	RadioBtn = ( CButton* )GetDlgItem( IDC_RADIO_Insertion7 );
	RadioBtn->SetCheck( 0 );
	RadioBtn->EnableWindow( FALSE );
	RadioBtn = ( CButton* )GetDlgItem( IDC_RADIO_Insertion6 );
	RadioBtn->SetCheck( 0 );
	RadioBtn->EnableWindow( FALSE );
	RadioBtn = ( CButton* )GetDlgItem( IDC_RADIO_Insertion5 );
	RadioBtn->SetCheck( 0 );
	RadioBtn->EnableWindow( FALSE );
	RadioBtn = ( CButton* )GetDlgItem( IDC_RADIO_Insertion4 );
	RadioBtn->SetCheck( 0 );
	RadioBtn->EnableWindow( FALSE );
	RadioBtn = ( CButton* )GetDlgItem( IDC_RADIO_Insertion3 );
	RadioBtn->SetCheck( 0 );
	RadioBtn->EnableWindow( FALSE );
	RadioBtn = ( CButton* )GetDlgItem( IDC_RADIO_Insertion2 );
	RadioBtn->SetCheck( 0 );
	RadioBtn->EnableWindow( FALSE );
	
	CEdit* SerialNum = ( CEdit* )GetDlgItem( IDC_EDIT_SerialNumber );
	SerialNum->EnableWindow( TRUE );
	
	UpdateData( FALSE );
}

//------------------------------------------------------------------------
// Enable Read Direction Radio Buttons Only
//------------------------------------------------------------------------
void CSampleAppDlg::EnableReadButton()
{
	CButton* RadioBtn = ( CButton* )GetDlgItem( IDC_RADIO_Insertion );
	RadioBtn->EnableWindow( TRUE );

	RadioBtn = ( CButton* )GetDlgItem( IDC_RADIO_Back );
	RadioBtn->EnableWindow( TRUE );
}

//------------------------------------------------------------------------
// Disable Read Direction Radio Buttons Only
//------------------------------------------------------------------------
void CSampleAppDlg::DisableReadButton()
{
	CButton* RadioBtn = ( CButton* )GetDlgItem( IDC_RADIO_Insertion );
	RadioBtn->EnableWindow( FALSE );
	RadioBtn = ( CButton* )GetDlgItem( IDC_RADIO_Back );
	RadioBtn->EnableWindow( FALSE );
}

//------------------------------------------------------------------------
// Enable Activate/Deactivate Button
//------------------------------------------------------------------------
void CSampleAppDlg::ChangeToActivate()
{
	UpdateData( TRUE );
	CButton* ActivateBtn = ( CButton* )GetDlgItem( IDC_BUTTON_Activate );
	ActivateBtn->EnableWindow( TRUE );
	ActivateBtn->SetWindowText( "Activate" );
	UpdateData( FALSE );
}

//------------------------------------------------------------------------
// Disable Activate/Deactivate Button
//------------------------------------------------------------------------
void CSampleAppDlg::ChangeToDeactivate()
{
	UpdateData( TRUE );
	CButton* ActivateBtn = ( CButton* )GetDlgItem( IDC_BUTTON_Activate );
	ActivateBtn->EnableWindow( TRUE );
	ActivateBtn->SetWindowText( "Deactivate" );
	UpdateData( FALSE );
}

//========================================================================
// Library
//========================================================================
//------------------------------------------------------------------------
// Check Read Status
//------------------------------------------------------------------------
DWORD CheckReadStatus(LPCOMCR_CARDSTATUS lpcCardStatus)
{
	DWORD dwRet = 0;
	if( lpcCardStatus->dwTrack1 == OMCR_CARD_STATUS_READSUCCESS )	dwRet |= OMCR_READ_TRACK_ISO1;
	if( lpcCardStatus->dwTrack2 == OMCR_CARD_STATUS_READSUCCESS )	dwRet |= OMCR_READ_TRACK_ISO2;
	if( lpcCardStatus->dwTrack3 == OMCR_CARD_STATUS_READSUCCESS )	dwRet |= OMCR_READ_TRACK_ISO3;
	return dwRet;
}

//------------------------------------------------------------------------
// Display Read Data
//------------------------------------------------------------------------
void CSampleAppDlg::DisplayReadData( LPCOMCR_MAGTRACK lpcMagTrack )
{
	this->m_strReadData.Empty();

	if( lpcMagTrack==NULL )
	{
		this->m_strReadData += "Track1 : Error.\r\n";
		this->m_strReadData += "Track2 : Error.\r\n";
		this->m_strReadData += "Track3 : Error.\r\n";
		UpdateData( FALSE );
		DisplayStatus( STATUS_READFAILURE );
		return;
	}

	CString strTmp;
	char	tmp1[sizeof( lpcMagTrack->bTrack1 )+1];
	char	tmp2[sizeof( lpcMagTrack->bTrack2 )+1];
	char	tmp3[sizeof( lpcMagTrack->bTrack3 )+1];
	int		tmp_len = 0;
	
	//Track 1
	if( ( lpcMagTrack->dwTrackStatus[0] ) == OMCR_STATUS_SUCCESS )
	{
		memcpy( tmp1, lpcMagTrack->bTrack1, lpcMagTrack->bTrackLen[0] );
		tmp1[lpcMagTrack->bTrackLen[0]] = '\0';
		strTmp  = "Track1 : ";
		strTmp += tmp1;
		strTmp += "\r\n";
		this->m_strReadData += strTmp;
	} else {
		this->m_strReadData += "Track1 : Error.\r\n";
	}
	//Track 2
	if( ( lpcMagTrack->dwTrackStatus[1] ) == OMCR_STATUS_SUCCESS )
	{
		memcpy( tmp2, lpcMagTrack->bTrack2, lpcMagTrack->bTrackLen[1] );
		tmp2[lpcMagTrack->bTrackLen[1]] = '\0';
		strTmp  = "Track2 : ";
		strTmp += tmp2;
		strTmp += "\r\n";
		this->m_strReadData += strTmp;
	} else {
		this->m_strReadData += "Track2 : Error.\r\n";
	}
	
	//Track 3
	if( ( lpcMagTrack->dwTrackStatus[2] ) == OMCR_STATUS_SUCCESS )
	{
		memcpy( tmp3, lpcMagTrack->bTrack3, lpcMagTrack->bTrackLen[2] );
		tmp3[lpcMagTrack->bTrackLen[2]] = '\0';
		strTmp  = "Track3 : ";
		strTmp += tmp3;
		strTmp += "\r\n";
		this->m_strReadData += strTmp;
	} else {
		this->m_strReadData += "Track3 : Error.\r\n";
	}
	UpdateData( FALSE );
}

//------------------------------------------------------------------------
// Display Error Message
//------------------------------------------------------------------------
void CSampleAppDlg::DisplayErrorMessage( CString strApiName, DWORD dwErrorCode )
{
	CString strErrorMessage, strErrorTitle;
	strErrorMessage.Format( "%s Failed.\nError Code = 0x%08X", strApiName, dwErrorCode );
	strErrorTitle.Format( "%s", strApiName );
	MessageBox( strErrorMessage, strErrorTitle, MB_ICONERROR );
}

//------------------------------------------------------------------------
// Display Status
//------------------------------------------------------------------------
void CSampleAppDlg::DisplayStatus( CString strStatus )
{
	this->m_edtStatus.SetWindowText( strStatus );
	this->m_edtStatus.RedrawWindow();
}

//------------------------------------------------------------------------
// Display Status for Reading Directions (using DisplayStatus)
//------------------------------------------------------------------------
void CSampleAppDlg::DisplayReadStatus()
{
	UpdateData( TRUE );
	if( this->m_nReadDirection == DIR_INSERTION )
	{
		DisplayStatus( NOTICE_INSERTION );
	} else {
		DisplayStatus( NOTICE_PULLOUT );
	}
}

//------------------------------------------------------------------------
// On "Read binary"
//------------------------------------------------------------------------
void CSampleAppDlg::OnBUTTONICCRead() 
{
	DWORD dwRet;
	CString strLockStatus;
	CButton* ActivateBtn = ( CButton* )GetDlgItem( IDC_BUTTON_Activate );
	ActivateBtn->GetWindowText( strLockStatus );
	
	if ( strLockStatus == "Deactivate" )
	{	
		dwRet = ICCRead();	
	}

	if ( dwRet != OMCR_STATUS_SUCCESS )
	{
		DisplayErrorMessage( "OMCR_" +strLockStatus, dwRet );
	}
	return;
}

//------------------------------------------------------------------------
// OMCR_CommunicateICC(Read)
//------------------------------------------------------------------------
DWORD CSampleAppDlg::ICCRead()
{
	//Set Activate and Change the Button Text to "Deactivate" when API succeed
	DWORD dwRet = OMCR_STATUS_SUCCESS;
	char buffer1[128];
	char buffer2[128];
	char buffer3[256];
	char tmp1[3];
	char tmp2[3];
	
	if ( this->lpcOmcr != NULL ) 
	{	
		StopReading();
		UpdateData( TRUE );
		
		this->m_strICWriteD.Empty();
		BYTE bSelectFile5V[] = {0x00, 0xA4, 0x02, 0x0C, 0x02, 0xAA, 0xAA};
		BYTE bSelectFile3V[] = {0x00, 0xA4, 0x02, 0x0C, 0x02, 0x00, 0x01};
		BYTE READB[] = {0x00, 0xB0, 0x00, 0x00, 0x3C};
		BYTE APDUB[] = {0x81, 0x48, 0x00, 0x00, 0x16, 0x00, 0x00, 0x2f, 0xaa, 0xaa, 0x00, 0x00, 0x00, 0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0x00, 0x00};
		OMCR_ICCIO in;
		OMCR_ICCIO out;
		int len;
		
		if ( dwRet == OMCR_STATUS_SUCCESS ) 
		{
			
			DisplayStatus( STATUS_READSTOPPED );
			this->m_strReadData.Empty();
			memset( buffer1, 0x00, sizeof( buffer1 ) );
			memset( buffer2, 0x00, sizeof( buffer2 ) );
			
			for(;;) 
			{
				UINT i;
				if ( strcmp( buffer, Toppan5VATR ) == 0 ) 
				{	
					len = sizeof( bSelectFile5V );
					in.dwProtocol = OMCR_CHIPIO_PROTOCOL_T1;
					memcpy( in.bData, bSelectFile5V, len );
					in.uLength = len;
					OMCR_CommunicateICC( this->lpcOmcr, &in , &out, NULL );
					
					for ( i = 0; i < out.uLength; i++ ) 
					{
						sprintf( tmp1, "%02X ", out.bData[i] );
						strcat( buffer1, tmp1 );	
					}
					
					this->m_strICCRW = buffer1;
					//Creation of a AAAAfile
					if ( this->m_strICCRW == "6A 82 " ) 
					{
						len = sizeof( APDUB );
						in.dwProtocol = OMCR_CHIPIO_PROTOCOL_T1;
						memcpy( in.bData, APDUB, len );
						in.uLength = len;
						OMCR_CommunicateICC( this->lpcOmcr, &in , &out, NULL );
						//It returns to a loop.
						continue;
					}
					
					//Data Read
					memcpy( in.bData, READB, ( sizeof( READB ) ) );
					in.dwProtocol = OMCR_CHIPIO_PROTOCOL_T1;
					in.uLength = sizeof( READB );
					OMCR_CommunicateICC( this->lpcOmcr, &in , &out, NULL );
					
					strcpy( buffer3, toppan5 );					
					strcat( buffer3, "\r\n");

					for ( i = 0; i < in.uLength; i++ ) 
					{
						sprintf( tmp1, "%02X ", in.bData[i] );
						strcat( buffer3, tmp1 );
					}

					this->m_strICData = buffer3;
					
					//Data Display
					for ( i = 0; i < out.uLength; i++ ) 
					{
						sprintf( tmp2, "%02X ", out.bData[i] );
						strcat( buffer2 , tmp2 ); 
					}					
					this->m_strICCRW = buffer2;
					break;					
				}
				
				//3VCard
				//3VCard?
				else if ( strcmp( buffer, Toppan3VATR ) == 0 ) 
				{	
					len = sizeof( bSelectFile3V );
					in.dwProtocol = OMCR_CHIPIO_PROTOCOL_T1;
					memcpy( in.bData, bSelectFile3V, len );
					in.uLength = len;
					OMCR_CommunicateICC( this->lpcOmcr, &in , &out , NULL );
					
					for ( UINT i = 0; i < out.uLength; i++ ) 
					{
						sprintf( tmp1, "%02X ", out.bData[i] );
						strcat( buffer1, tmp1 );
					}
				//Data Read	
					memcpy( in.bData,READB, sizeof( READB ) );
					in.dwProtocol = OMCR_CHIPIO_PROTOCOL_T1;
					in.uLength = sizeof( READB );
					OMCR_CommunicateICC( this->lpcOmcr, &in , &out, NULL );
					strcpy( buffer3, toppan3 );					
					strcat( buffer3, "\r\n" );

					for ( i = 0; i < in.uLength; i++ ) 
					{
						sprintf( tmp1, "%02X ", in.bData[i] );
						strcat( buffer3, tmp1 );
					}

					this->m_strICData = buffer3;
					//Data Display
					for ( i = 0; i < out.uLength; i++ ) 
					{
						sprintf( tmp2, "%02X ", out.bData[i] );
						strcat( buffer2 , tmp2 ); 
					}
					
					this->m_strICCRW = buffer2;
					break;
				} else {
					//Other Cards
					this->m_strICCRW = "They are other cards.";
					//CButton* Btn = ( CButton* )GetDlgItem( IDC_BUTTON_OpenDevice );
					CButton* ReadBtn = ( CButton* )GetDlgItem( IDC_BUTTON_ICCRead );
					ReadBtn->EnableWindow( FALSE );
					CButton* WriteBtn = ( CButton* )GetDlgItem( IDC_BUTTON_ICCWrite );
					WriteBtn->EnableWindow( FALSE );
					break;
				}
			}
		}
	}
	UpdateData( FALSE );
	
	return dwRet;
}

//------------------------------------------------------------------------
// On "Write binary"
//------------------------------------------------------------------------
void CSampleAppDlg::OnBUTTONICCWrite() 
{
//	DWORD dwRet;
	CString strLockStatus;
	CButton* ActivateBtn = ( CButton* )GetDlgItem( IDC_BUTTON_Activate );
	ActivateBtn->GetWindowText( strLockStatus );

	if ( strLockStatus == "Deactivate" ) 
	{	
		ICCWrite();	
	}

/*	if ( dwRet != OMCR_STATUS_SUCCESS )
	{
		DisplayErrorMessage( "OMCR_" +strLockStatus, dwRet );
	}
*/	
	return;
}

//------------------------------------------------------------------------
// OMCR_CommunicateICC(Write)
//------------------------------------------------------------------------
void CSampleAppDlg::ICCWrite()
{
	DWORD dwRet = OMCR_STATUS_SUCCESS;
	char buffer1[128];
	char buffer2[128];
	char buffer3[128];
	char buffer4[128];
	char buffer5[1024];
	char tmp1[3];
	char tmp2[3];
	
	if ( this->lpcOmcr != NULL ) 
	{	
		StopReading();
		UpdateData( TRUE );
		//A focus is moved to the DataWrite.
		CButton* WriteD = ( CButton* )GetDlgItem( IDC_EDIT3 );
		WriteD->SetFocus();
		
		BYTE bSelectFile5V[] = {0x00, 0xA4, 0x02, 0x0C, 0x02, 0xAA, 0xAA};
		BYTE bSelectFile3V[] = {0x00, 0xA4, 0x02, 0x0C, 0x02, 0x00, 0x01};
		BYTE WRITEB[] = {0x00, 0xD6, 0x00, 0x00};
		BYTE APDUB[] = {0x81, 0x48, 0x00, 0x00, 0x16, 0x00, 0x00, 0x2f, 0xaa, 0xaa, 0x00, 0x00, 0x00, 0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0x00, 0x00};
		BYTE BB[1];
		char APDUD[] = "\r\n00 D6 00 00 ";
		char ss[128];
		OMCR_ICCIO in;
		OMCR_ICCIO out;
		int len;
		UINT i;
		
		if ( dwRet == OMCR_STATUS_SUCCESS ) 
		{	
			DisplayStatus( STATUS_READSTOPPED );
			this->m_strReadData.Empty();

			memset( buffer1, 0x00, sizeof( buffer1 ) );
			memset( buffer3, 0x00, sizeof( buffer3 ) );
			memset( buffer2, 0x00, sizeof( buffer2 ) );
			memset( buffer4, 0x00, sizeof( buffer4 ) );
			
			strcpy( ss, this->m_strICWriteD );
			//The size of the written-in data
			int size = strlen( ss );

			BYTE* buffer6 = ( BYTE* )malloc( sizeof( BYTE )*size );
			//It changes to binary mode.
			BOOL ref = TransAsciiToBinary( m_strICWriteD, buffer6, &size );
			//If it is an imitation
			if ( ref == FALSE ) 
			{	
				//Write Data space clear & The display of an error message
				this->m_strICWriteD.Empty();
				UpdateData( FALSE );
				MessageBox( TEXT( "A character cannot be inputted." ), NULL, MB_OK );
				return;	
			}

			//60 or more characters make an error.
			if( strlen( ss ) > 60 ) 
			{	
				this->m_strICWriteD.Empty();
				UpdateData( FALSE ); 
				MessageBox( TEXT( "It cannot be written that 60 characters are surpassed." ), NULL, MB_OK );
				return;	
			}
			
			//Write Data size
			BB[0] = ( unsigned char ) size;
			
			for(;;)
			{
				//5VCard Write
				//5VCard?
				if ( strcmp( buffer, Toppan5VATR ) == 0 )
				{	
					
					len = sizeof( bSelectFile5V );
					in.dwProtocol = OMCR_CHIPIO_PROTOCOL_T1;
					memcpy( in.bData, bSelectFile5V, len );
					in.uLength = len;
					OMCR_CommunicateICC( this->lpcOmcr, &in , &out, NULL );
					
					for ( i = 0; i < out.uLength; i++ ) 
					{
						sprintf( tmp1, "%02X ", out.bData[i] );
						strcat( buffer1, tmp1 );
					}
					
					this->m_strICWriteD = buffer1;
					//Creation of a AAAAfile
					if ( this->m_strICWriteD == "6A 82 " ) 
					{
						len = sizeof( APDUB );
						in.dwProtocol = OMCR_CHIPIO_PROTOCOL_T1;
						memcpy( in.bData, APDUB, len );
						in.uLength = len;
						OMCR_CommunicateICC( this->lpcOmcr, &in , &out, NULL );
						continue;
					}
					
					for( i = 0; i < sizeof( WRITEB ); i++ ) 
					{
						buffer3[i] = WRITEB[i];
					}
					//The length of data is stored.
					buffer3[i] = BB[0];
					i++;
								
					for(int j = 0; j < size; j++,i++ ) 
					{
						buffer3[i] = buffer6[j];
					}
					
					memcpy( in.bData, buffer3, size + sizeof( WRITEB ) + 1 );
					in.dwProtocol = OMCR_CHIPIO_PROTOCOL_T1;
					in.uLength = size + sizeof( WRITEB ) + 1;
					OMCR_CommunicateICC( this->lpcOmcr, &in , &out, NULL );
					
					strcpy( buffer5, toppan5 );					
					strcat( buffer5, "\r\n" );

					for ( i = 0; i < in.uLength; i++ ) 
					{
						sprintf( tmp1, "%02X ", in.bData[i] );
						strcat( buffer5, tmp1 );
					}

					this->m_strICData = buffer5;
					
					for (i = 0; i < out.uLength; i++ ) 
					{
						sprintf( tmp2, "%02X ", out.bData[i] );
						strcat( buffer4 , tmp2 ); 
					}
					
					this->m_strICWriteD = buffer4;
					//A wite-in success
					if ( this->m_strICWriteD == "90 00 " ) 
					{
						MessageBox(TEXT("A wite-in success"),NULL, MB_OK);
						this->m_strICWriteD.Empty();
					}
					//Write-in failure
					else {		
						MessageBox( TEXT( "Write-in failure" ), NULL, MB_OK );
						this->m_strICWriteD.Empty();
					}
					break;
				}
				//3VCard
				//3VCard?
				else if ( strcmp( buffer, Toppan3VATR ) == 0 ) 
				{	
					len = sizeof( bSelectFile3V );
					in.dwProtocol = OMCR_CHIPIO_PROTOCOL_T1;
					memcpy( in.bData, bSelectFile3V, len );
					in.uLength = len;
					OMCR_CommunicateICC( this->lpcOmcr, &in , &out, NULL );
					
					for ( UINT i = 0; i < out.uLength; i++ ) 
					{
						sprintf( tmp1, "%02X ", out.bData[i] );
						strcat( buffer1, tmp1 );
					}					
					
					for( i = 0; i < sizeof( WRITEB ); i++ ) 
					{
						buffer3[i] = WRITEB[i];
					}
					
					buffer3[i] = BB[0];
					i++;
					
					for(int j = 0; j < size; j++,i++ ) 
					{
						buffer3[i] = buffer6[j];
					}
					
					memcpy( in.bData, buffer3, size + sizeof( WRITEB ) + 1 );
					in.dwProtocol = OMCR_CHIPIO_PROTOCOL_T1;
					in.uLength = size + sizeof( WRITEB ) + 1;
					OMCR_CommunicateICC( this->lpcOmcr, &in , &out, NULL );
					
					strcpy( buffer5,toppan3 );					
					strcat( buffer5, "\r\n" );

					for ( i = 0; i < in.uLength; i++ ) 
					{
						sprintf( tmp1, "%02X ", in.bData[i] );
						strcat( buffer5, tmp1 );
					}

					this->m_strICData = buffer5;
					
					for (i = 0; i < out.uLength; i++ ) 
					{
						sprintf( tmp2,"%02X ", out.bData[i] );
						strcat( buffer4 , tmp2 ); 
					}
					
					this->m_strICWriteD = buffer4;
					if ( this->m_strICWriteD == "90 00 " ) 
					{	
						//	this->m_strICWriteD = "A write-in success";
						MessageBox( TEXT( "A wite-in success" ), NULL, MB_OK );
						this->m_strICWriteD.Empty();
					}
					else 
					{
						MessageBox( TEXT( "Write-in failure" ), NULL, MB_OK );
						this->m_strICWriteD.Empty();
					}					
					break;
				}
				//Other Cards
				else 
				{
					this->m_strICCRW = "They are other cards.";
					//CButton* pBtn = ( CButton* )GetDlgItem( IDC_BUTTON_OpenDevice );
					CButton* ReadBtn = ( CButton* )GetDlgItem( IDC_BUTTON_ICCRead );
					ReadBtn->EnableWindow( FALSE );
					CButton* WriteBtn = ( CButton* )GetDlgItem( IDC_BUTTON_ICCWrite );
					WriteBtn->EnableWindow( FALSE );
					break;
				}
			}
		}
	}
	UpdateData( FALSE );	
}

//------------------------------------------------------------------------
// Trun on GreenLED
//------------------------------------------------------------------------
void CSampleAppDlg::OnButtonLedG() 
{	
	StopReading();

	CButton* LEDGBtn = ( CButton* )GetDlgItem( IDC_BUTTON_LEDG );
	LEDGBtn->EnableWindow( TRUE );
	LEDGBtn->SetCheck( 1 );

	flg3 = 1;
	flg4 = 0;
	flg5 = 0;

	CButton* LEDRBtn = ( CButton* )GetDlgItem( IDC_BUTTON_LEDR );
	LEDRBtn->EnableWindow( TRUE );
	CButton* LEDOBtn = ( CButton* )GetDlgItem( IDC_BUTTON_LEDO );
	LEDOBtn->EnableWindow( TRUE );
	CButton* RadioBtn = ( CButton* )GetDlgItem( IDC_RADIO_Insertion7 );
	SetDefID( IDC_RADIO_Insertion7 );

	LEDGBtn->SetCheck( 1 );
	LEDRBtn->SetCheck( 0 );
	LEDOBtn->SetCheck( 0 );

	RadioBtn->SetCheck( 1 );
	RadioBtn = ( CButton* )GetDlgItem( IDC_RADIO_Insertion6 );
	RadioBtn->SetCheck( 0 );
	RadioBtn = ( CButton* )GetDlgItem( IDC_RADIO_Insertion5 );
	RadioBtn->SetCheck( 0 );
	RadioBtn = ( CButton* )GetDlgItem( IDC_RADIO_Insertion4 );
	RadioBtn->SetCheck( 0 );
	RadioBtn = ( CButton* )GetDlgItem( IDC_RADIO_Insertion3 );
	RadioBtn->SetCheck( 0 );
	RadioBtn = ( CButton* )GetDlgItem( IDC_RADIO_Insertion2 );
	RadioBtn->SetCheck( 0 );

	OMCR_TurnonLED( this->lpcOmcr, OMCR_SET_LED_COLOR_GREEN, NULL );
	
	if( !flg ) 
	{
		StartReading();
	}
}

//------------------------------------------------------------------------
// Trun on RedLED
//------------------------------------------------------------------------
void CSampleAppDlg::OnButtonLedR() 
{
	StopReading();
	CButton* LEDGBtn = ( CButton* )GetDlgItem( IDC_BUTTON_LEDG );
	CButton* LEDRBtn = ( CButton* )GetDlgItem( IDC_BUTTON_LEDR );
	CButton* LEDOBtn = ( CButton* )GetDlgItem( IDC_BUTTON_LEDO );
	CButton* RadioBtn = ( CButton* )GetDlgItem( IDC_RADIO_Insertion7 );
	SetDefID( IDC_RADIO_Insertion7 );

	LEDOBtn->SetCheck( 0 );
	LEDGBtn->SetCheck( 0 );
	RadioBtn->SetCheck( 1 );
	LEDRBtn->SetCheck( 1 );
	
	flg3 = 0;
	flg4 = 1;
	flg5 = 0;

	RadioBtn = ( CButton* )GetDlgItem( IDC_RADIO_Insertion6 );
	RadioBtn->SetCheck( 0 );
	RadioBtn = ( CButton* )GetDlgItem( IDC_RADIO_Insertion5 );
	RadioBtn->SetCheck( 0 );
	RadioBtn = ( CButton* )GetDlgItem( IDC_RADIO_Insertion4 );
	RadioBtn->SetCheck( 0 );
	RadioBtn = ( CButton* )GetDlgItem( IDC_RADIO_Insertion3 );
	RadioBtn->SetCheck( 0 );
	RadioBtn = ( CButton* )GetDlgItem( IDC_RADIO_Insertion2 );
	RadioBtn->SetCheck( 0 );

	OMCR_TurnonLED( this->lpcOmcr, OMCR_SET_LED_COLOR_RED, NULL );
	LEDRBtn->SetCheck( 1 );
	
	UpdateData( FALSE );

	if(!flg) 
	{
		StartReading();
	}
}

//------------------------------------------------------------------------
// Trun on OrangeLED
//------------------------------------------------------------------------
void CSampleAppDlg::OnButtonLedgO() 
{

	StopReading();
	CButton* LEDGBtn = ( CButton* )GetDlgItem( IDC_BUTTON_LEDG );
	CButton* LEDRBtn = ( CButton* )GetDlgItem( IDC_BUTTON_LEDR );
	CButton* LEDOBtn = ( CButton* )GetDlgItem( IDC_BUTTON_LEDO );
	CButton* RadioBtn = ( CButton* )GetDlgItem( IDC_RADIO_Insertion7 );
	SetDefID( IDC_RADIO_Insertion7 );

	LEDRBtn->SetCheck( 0 );
	LEDGBtn->SetCheck( 0 );
	RadioBtn->SetCheck( 1 );
	
	flg3 = 0;
	flg4 = 0;
	flg5 = 1;

	LEDOBtn->SetCheck( 1 );
	RadioBtn = ( CButton* )GetDlgItem( IDC_RADIO_Insertion6 );
	RadioBtn->SetCheck( 0 );
	RadioBtn = ( CButton* )GetDlgItem( IDC_RADIO_Insertion5 );
	RadioBtn->SetCheck( 0 );
	RadioBtn = ( CButton* )GetDlgItem( IDC_RADIO_Insertion4 );
	RadioBtn->SetCheck( 0 );
	RadioBtn = ( CButton* )GetDlgItem( IDC_RADIO_Insertion3 );
	RadioBtn->SetCheck( 0 );
	RadioBtn = ( CButton* )GetDlgItem( IDC_RADIO_Insertion2 );
	RadioBtn->SetCheck( 0 );
	
	OMCR_TurnonLED( this->lpcOmcr, OMCR_SET_LED_COLOR_ORANGE, NULL );

	LEDOBtn->SetCheck( 1 );

	UpdateData( FALSE );
	
	if( !flg ) 
	{
		StartReading();
	}
}

//------------------------------------------------------------------------
// The cycles of 1sec
//------------------------------------------------------------------------
void CSampleAppDlg::OnRADIO1sec() 
{
	StopReading();
	UpdateData( TRUE );
	CButton* LEDGBtn = ( CButton* )GetDlgItem( IDC_BUTTON_LEDG );
	CButton* LEDRBtn = ( CButton* )GetDlgItem( IDC_BUTTON_LEDR );
	CButton* LEDOBtn = ( CButton* )GetDlgItem( IDC_BUTTON_LEDO );
	BOOL Checkflg = LEDGBtn->GetCheck();
	if ( Checkflg | flg3 ) 
	{
		OMCR_BlinkLED( this->lpcOmcr, OMCR_SET_LED_COLOR_GREEN, OMCR_SET_LED_BLINK1HZ, NULL );
	}
	if ( Checkflg = LEDRBtn->GetCheck() | flg4 ) 
	{
		OMCR_BlinkLED( this->lpcOmcr, OMCR_SET_LED_COLOR_RED, OMCR_SET_LED_BLINK1HZ, NULL );
	}
	if ( Checkflg = LEDOBtn->GetCheck() | flg5 ) 
	{
		OMCR_BlinkLED( this->lpcOmcr, OMCR_SET_LED_COLOR_ORANGE, OMCR_SET_LED_BLINK1HZ, NULL );
	}

	UpdateData( FALSE );
	
	if( !flg ) 
	{
		StartReading();
	}
}

//------------------------------------------------------------------------
// The cycles of 2sec
//------------------------------------------------------------------------
void CSampleAppDlg::OnRADIOSec2() 
{
	StopReading();
	UpdateData( TRUE );
	CButton* LEDGBtn = ( CButton* )GetDlgItem( IDC_BUTTON_LEDG );
	CButton* LEDRBtn = ( CButton* )GetDlgItem( IDC_BUTTON_LEDR );
	CButton* LEDOBtn = ( CButton* )GetDlgItem( IDC_BUTTON_LEDO );
	BOOL Checkflg = LEDGBtn->GetCheck();
	
	if ( Checkflg | flg3 ) 
	{
		OMCR_BlinkLED( this->lpcOmcr, OMCR_SET_LED_COLOR_GREEN, OMCR_SET_LED_BLINK1_2HZ, NULL );
	}
	if ( Checkflg = LEDRBtn->GetCheck() | flg4 ) 
	{
		OMCR_BlinkLED( this->lpcOmcr, OMCR_SET_LED_COLOR_RED, OMCR_SET_LED_BLINK1_2HZ, NULL );
	}
	if ( Checkflg = LEDOBtn->GetCheck() | flg5 ) 
	{
		OMCR_BlinkLED( this->lpcOmcr, OMCR_SET_LED_COLOR_ORANGE, OMCR_SET_LED_BLINK1_2HZ, NULL );
	}

	UpdateData( FALSE );
		
	if( !flg ) 
	{
		StartReading();
	}
}

//------------------------------------------------------------------------
// The cycles of 4sec
//------------------------------------------------------------------------
void CSampleAppDlg::OnRADIOSec4() 
{
	StopReading();
	UpdateData( TRUE );
	CButton* LEDGBtn = ( CButton* )GetDlgItem( IDC_BUTTON_LEDG );
	CButton* LEDRBtn = ( CButton* )GetDlgItem( IDC_BUTTON_LEDR );
	CButton* LEDOBtn = ( CButton* )GetDlgItem( IDC_BUTTON_LEDO );
	BOOL Checkflg = LEDGBtn->GetCheck();
	
	if ( Checkflg | flg3 ) 
	{
		OMCR_BlinkLED( this->lpcOmcr, OMCR_SET_LED_COLOR_GREEN, OMCR_SET_LED_BLINK1_4HZ, NULL );
	}
	if ( Checkflg = LEDRBtn->GetCheck() | flg4 ) 
	{
		OMCR_BlinkLED( this->lpcOmcr, OMCR_SET_LED_COLOR_RED, OMCR_SET_LED_BLINK1_4HZ, NULL );
	}
	if ( Checkflg = LEDOBtn->GetCheck() | flg5 ) 
	{
		OMCR_BlinkLED( this->lpcOmcr, OMCR_SET_LED_COLOR_ORANGE, OMCR_SET_LED_BLINK1_4HZ, NULL);
	}

	UpdateData( FALSE );
		
	if( !flg ) 
	{
		StartReading();
	}
}

//------------------------------------------------------------------------
// The cycles of 500msec
//------------------------------------------------------------------------
void CSampleAppDlg::OnRADIOmsec500() 
{
	StopReading();
	UpdateData( TRUE );
	
	CButton* LEDGBtn = ( CButton* )GetDlgItem( IDC_BUTTON_LEDG );
	CButton* LEDRBtn = ( CButton* )GetDlgItem( IDC_BUTTON_LEDR );
	CButton* LEDOBtn = ( CButton* )GetDlgItem( IDC_BUTTON_LEDO );
	BOOL Checkflg = LEDGBtn->GetCheck();

	if ( Checkflg | flg3 ) 
	{
		OMCR_BlinkLED( this->lpcOmcr, OMCR_SET_LED_COLOR_GREEN, OMCR_SET_LED_BLINK2HZ, NULL );
	}
	if ( Checkflg = LEDRBtn->GetCheck() | flg4 ) 
	{
		OMCR_BlinkLED( this->lpcOmcr, OMCR_SET_LED_COLOR_RED, OMCR_SET_LED_BLINK2HZ, NULL );
	}
	if ( Checkflg = LEDOBtn->GetCheck() | flg5 ) 
	{
		OMCR_BlinkLED( this->lpcOmcr, OMCR_SET_LED_COLOR_ORANGE, OMCR_SET_LED_BLINK2HZ, NULL );
	}

	UpdateData( FALSE );
		
	if( !flg ) 
	{
		StartReading();
	}
}

//------------------------------------------------------------------------
// The cycles of 250msec
//------------------------------------------------------------------------
void CSampleAppDlg::OnRADIOmsec250() 
{
	StopReading();
	UpdateData( TRUE );

	CButton* LEDGBtn = ( CButton* )GetDlgItem( IDC_BUTTON_LEDG );
	CButton* LEDRBtn = ( CButton* )GetDlgItem( IDC_BUTTON_LEDR );
	CButton* LEDOBtn = ( CButton* )GetDlgItem( IDC_BUTTON_LEDO );
	BOOL Checkflg = LEDGBtn->GetCheck();	
	
	if ( Checkflg | flg3 ) 
	{
		OMCR_BlinkLED( this->lpcOmcr, OMCR_SET_LED_COLOR_GREEN, OMCR_SET_LED_BLINK4HZ, NULL );
	}
	if ( Checkflg = LEDRBtn->GetCheck() | flg4 ) 
	{
		OMCR_BlinkLED( this->lpcOmcr, OMCR_SET_LED_COLOR_RED, OMCR_SET_LED_BLINK4HZ, NULL );
	}
	if ( Checkflg = LEDOBtn->GetCheck() | flg5 ) 
	{
		OMCR_BlinkLED( this->lpcOmcr, OMCR_SET_LED_COLOR_ORANGE, OMCR_SET_LED_BLINK4HZ, NULL);
	}
	
	UpdateData( FALSE );
		
	if( !flg ) 
	{
		StartReading();
	}
}

//------------------------------------------------------------------------
// On "keep"
//------------------------------------------------------------------------
void CSampleAppDlg::OnRADIOsec0() 
{
	StopReading();
	UpdateData( TRUE );

	CButton* LEDGBtn = ( CButton* )GetDlgItem( IDC_BUTTON_LEDG );
	CButton* LEDRBtn = ( CButton* )GetDlgItem( IDC_BUTTON_LEDR );
	CButton* LEDOBtn = ( CButton* )GetDlgItem( IDC_BUTTON_LEDO );
	BOOL Checkflg = LEDGBtn->GetCheck();

	if ( Checkflg | flg3 ) 
	{
		OMCR_TurnonLED( this->lpcOmcr, OMCR_SET_LED_COLOR_GREEN, NULL );
	}
	if ( Checkflg = LEDRBtn->GetCheck() | flg4 ) 
	{
		OMCR_TurnonLED( this->lpcOmcr, OMCR_SET_LED_COLOR_RED, NULL );
	}
	if ( Checkflg = LEDOBtn->GetCheck() | flg5 ) 
	{
		OMCR_TurnonLED( this->lpcOmcr, OMCR_SET_LED_COLOR_ORANGE, NULL );
	}
	
	UpdateData( FALSE );

	if(!flg) 
	{
		StartReading();
	}
}

//------------------------------------------------------------------------
// On "OFF"
//------------------------------------------------------------------------
void CSampleAppDlg::OnButtonLedout() 
{
	StopReading();
	UpdateData( TRUE );

	OMCR_TurnoffLED(this->lpcOmcr,NULL);
	CButton* LEDOUT = ( CButton* )GetDlgItem( IDC_BUTTON_LEDG );
	LEDOUT->SetCheck( 0 );
	LEDOUT->SetState( 0 );

	LEDOUT = ( CButton* )GetDlgItem( IDC_BUTTON_LEDR );
	LEDOUT->SetCheck( 0 );
	LEDOUT->SetState( 0 );
	
	LEDOUT = ( CButton* )GetDlgItem( IDC_BUTTON_LEDO );
	LEDOUT->SetCheck( 0 );
	LEDOUT->SetState( 0 );
	
	LEDOUT = ( CButton* )GetDlgItem( IDC_RADIO_Insertion7 );
	LEDOUT->SetCheck( 0 );
	LEDOUT->SetState( 0 );
	
	LEDOUT = ( CButton* )GetDlgItem( IDC_RADIO_Insertion6 );
	LEDOUT->SetCheck( 0 );
	
	LEDOUT = ( CButton* )GetDlgItem( IDC_RADIO_Insertion5 );
	LEDOUT->SetCheck( 0 );
	
	LEDOUT = ( CButton* )GetDlgItem( IDC_RADIO_Insertion4 );
	LEDOUT->SetCheck( 0 );
	
	LEDOUT = ( CButton* )GetDlgItem( IDC_RADIO_Insertion3 );
	LEDOUT->SetCheck( 0 );
	
	LEDOUT = ( CButton* )GetDlgItem( IDC_RADIO_Insertion2 );
	LEDOUT->SetCheck( 0 );
	//flg clear
	flg3 = 0;
	flg4 = 0;
	flg5 = 0;
	UpdateData( FALSE );
	
	if( !flg ) 
	{
		StartReading();
	}
}

//------------------------------------------------------------------------
// Trans Ascii To Binary
//------------------------------------------------------------------------
BOOL WINAPI TransAsciiToBinary( CString strAsc, BYTE* pBin, int *nLen )
{
	enum charType 
	{
		ASCII,
			BINARY,
			UNDEFINED
	};
	int		nCounter	= 0;
	int		nStatus		= ASCII;
	char	*c			= ( char* )( ( LPCSTR )strAsc );
	char	ch[3];
		
	memset( pBin, 0x00, sizeof( pBin ) );
	while ( *c ) 
	{
		switch ( nStatus ) 
		{
		case ASCII:
			if ( *c == '{' ) 
			{
				nStatus = BINARY;
			}
	
			else 
			{
				pBin[nCounter++] = *c;
				
			}
			break;

		case BINARY:
			if ( *c != '}' )
			{
				memset( ch, 0x00, sizeof( ch ) );
				if ( isxdigit( *c ) ) 
				{
					ch[0] = *c++;
				} else if ( ( *c == ' ') || ( *c == ',' ) )
				{
					break;
				} else
				{
					nStatus = UNDEFINED;
					break;
				}
				if ( isxdigit( *c ) ) 
				{
					ch[1] = *c;
				} else if ( ( *c == ' ' ) || ( *c == ',' ) || (*c == '}' ) )
				{
					if ( !isxdigit( ch[0] ) ) 
					{
						nStatus = UNDEFINED;
						break;
					}
					if ( *c == '}') {
						nStatus = ASCII;
					}
				} else{
					nStatus = UNDEFINED;
					break;
				}
				char *stop;
				pBin[nCounter++] = ( BYTE )( strtol( ch, &stop, 16 ) );
			} else{
				nStatus = ASCII;
			}
			break;
		}
		if ( nStatus == UNDEFINED )
		{
			break;
		} else{
			c++;
		}
	}
	*nLen = nCounter;
	if ( nStatus == UNDEFINED )
	{
		return FALSE;
	}
	return TRUE;
}
